;********************************************************************************************************
;13/04/2006 : Highscores bug
;02/26/2006 : Mouse movement (1 player) and joystick (not tested)
;05/28/2004 : Translation, Open Source version
;11/30/2003 : Scores saving, direction tracing
;07/07/2003 : New scores, new computer mode
;04/26/2003 : Main loop timers (no more frame syncing :-(). Removed an unused IA routine. Created a "letters balls" version
;03/29/2003 : Player winner timing. 'll have to redo all game timing.
;01/31/2003 : Boom timing bug. Slower levels apparition
;01/27/2003 : Arrows keys for 1 player mode, levels loading with levels.txt file
;08-22/09   : Menu, new music, little ai by levels, changed all files names, new levels
;08/09/2002 : Stupid AI; file loading error warning
;08/07/2002 : Slow GFX cards boom bug fix
;14/06/2002 : Lowest new balls speed
;01/06/2002 : Restore data on change mode bug fixed
;31/05/2002 : Windowed mode, levels design
;19/05/2002 : 0.67 Source crash! Lonely ball bug fix (again)
;23/08/2001 : balls positions creation bug
;07/23/2001 : little first time slow imagecollide bug fixed, text bug fixed, lonely ball bug fixed (waiting for exploding balls to finish falling before launching opponents balls)
;06/30/2001 : moved deplace_balls after imagecollide to avoid unexpecting drawing
;06/27/2001 : Bounce bug corrected
;			: gfx for menu
;06/19/2001 : Some bugs corrected
;			: Worked on timing
;			: Boom disabled if computer too slow
;			: Top key : arrow to the top
;06/14/2001 : 16 bit->faster
;			: Changing the way of drawing arrows and adjusted position
;			: Thinking of changing qblit to use timers
;			: New balls colors
;			: boom's bug
;			: Winner
;06/13/2001 : Arrows remade
;			: Flying logo
;			: Bug qblit width
;06/12/2001 : V0.6
;			: 800*600 update!
;			: All GFX dones except arrows
;			: corrected float to int bug (have to create an int var, and just copy the float to this)
;05/10/2001 : V0.53
;			: constants for 800*600
;			: bug rnd -> rand
;			: boom scroll added (terribly lame, but no other choice)
;			: complete reorg of the code (subroutines)
;			: full screen if possible (lowres)
;05/07/2001	: V0.52
;			: some bugs fixed
;05/05/2001	: V0.5
;			; First release For PC
;??/??/98	: amiga version, angle sens anti-horaire, 0 en bas
;********************************************************************************************************

AppTitle "Bobble Puzzle"

Const xpl1=40,ypl1=40,xpl2=440,ypl2=40,intervx=20,intervy=35,ball_width=40,ball_height=40,ball_ray_x=ball_width/2,ball_ray_y=ball_height/2
Const nb_balls_x=8,nb_balls_y=11

Const k_music=109,k_pause=25									;keys
Const k_pl1_left=46 ,k_pl1_middle=33 ,k_pl1_right=47 ,k_pl1_fire=29, k_pl1_fire2=57
Const k_pl2_left=203,k_pl2_middle=200,k_pl2_right=205,k_pl2_fire=54, k_pl2_fire2=82
Const k_trace=20

Const pl1_ball_speed=12
Const pl2_ball_speed=12
Const plai_ball_speed=12

version$="0.90"


Type ball1
	Field x,y,num
End Type
Type ball2
	Field x,y,num
End Type
Type ballai
	Field x,y,num
End Type
Type falling_ball1
	Field x,y,num,vit,vitx
End Type
Type falling_ball2
	Field x,y,num,vit,vitx	
End Type
Type falling_ballai
	Field x,y,num,vit,vitx	
End Type
Type climbing_ball1
	Field x,y,num,vit
End Type
Type climbing_ball2
	Field x,y,num,vit
End Type
Type climbing_ballai
	Field x,y,num,vit
End Type
Type blitlist
	Field handl,x,y,frame,db
End Type
Type qobjet0
	Field x,y,w,h
End Type
Type qobjet1
	Field x,y,w,h
End Type

.variables
Dim array1(16,12),array2(16,12),arrayai(16,12),fsin#(720),fcos#(720),ballslaunched(5000)
Dim arraydec1(16,12),arraydec2(16,12),arraydecai(16,12)
Dim oldmsk(200)
Dim xfalling(1000)
Dim bitmap(4),image(7),sons(5)
Dim flyinglogo(12)
Dim results_ai(4096,5)			;score,angle,x,y,bouncing counter
Dim bl(8,12)					;array to load level (lazy man)
Dim computer_difficulty(50,2)
Dim hs_scores(10),hs_name$(10),hs_levels(10)


Global same1.ball1,explode1.falling_ball1,stack1.climbing_ball1,sonplayer1=0,b1,nbsameballs1
Global same2.ball2,explode2.falling_ball2,stack2.climbing_ball2,sonplayer2=0,b2,nbsameballs2
Global sameai.ballai,explodeai.falling_ballai,stackai.climbing_ballai,bai,nbsameballsai
Global stackb1,effectivestackb1,loose1,nbstack1
Global stackb2,effectivestackb2,loose2,nbstack2
Global stackbai,effectivestackai,looseai,nbstackai
Global qobjets0.qobjet0,qobjets1.qobjet1,liste.blitlist
Global balls,mask,maskballs,guide
Global mem_ai,numb2,guide_movement,option_trace

xb1#=0 : yb1#=0					;variables type definition
xb2#=0 : yb2#=0 : vol#=0
x%=0   : y%=0 
xt%=0  : yt%=0
boom#=0: ampli#=0 :i#=0 : o#=0 : u=0
niveau=0
option_trace=False

same1.ball1=New ball1
same2.ball2=New ball2
;mem_ai=CreateBank(905216)


;********************************************************************************************************

Function testarray1(xt,yt)
	If array1(xt,yt)<>b1 Then Return
	same1.ball1=New ball1
	same1\x=xt:same1\y=yt:same1\num=b1
	array1(xt,yt)=-1
	nbsameballs1=nbsameballs1+1
	If xt>1 Then testarray1(xt-2,yt)
	If xt<13 Then testarray1(xt+2,yt)
	If (xt>0) And (yt>0) Then testarray1(xt-1,yt-1)
	If (yt>0) And (xt<14) Then testarray1(xt+1,yt-1)
	If (yt<11) And (xt>0 )Then testarray1(xt-1,yt+1)
	If (yt<11) And (xt<14) Then testarray1(xt+1,yt+1)
End Function

;*****************************************************************

Function testarray2(xt,yt)
	If array2(xt,yt)<>b2 Then Return
	same2.ball2=New ball2
	same2\x=xt:same2\y=yt:same2\num=b2
	array2(xt,yt)=-1
	nbsameballs2=nbsameballs2+1
	If xt>1 Then testarray2(xt-2,yt)
	If xt<13 Then testarray2(xt+2,yt)
	If (xt>0) And (yt>0) Then testarray2(xt-1,yt-1)
	If (yt>0) And (xt<14) Then testarray2(xt+1,yt-1)
	If (yt<11) And (xt>0) Then testarray2(xt-1,yt+1)
	If (yt<11) And (xt<14) Then testarray2(xt+1,yt+1)
End Function

;*****************************************************************

Function testarrayai(xt,yt)
	If arrayai(xt,yt)<>b2 Then Return
	sameai.ballai=New ballai
	sameai\x=xt:sameai\y=yt:sameai\num=bai
	arrayai(xt,yt)=-1
	nbsameballsai=nbsameballsai+1
	If xt>1 Then testarrayai(xt-2,yt)
	If xt<13 Then testarrayai(xt+2,yt)
	If (xt>0) And (yt>0) Then testarrayai(xt-1,yt-1)
	If (yt>0) And (xt<14) Then testarrayai(xt+1,yt-1)
	If (yt<11) And (xt>0) Then testarrayai(xt-1,yt+1)
	If (yt<11) And (xt<14) Then testarrayai(xt+1,yt+1)
End Function

;*****************************************************************

Function testdec1(xt,yt)
	If (array1(xt,yt)=-1) Or (arraydec1(xt,yt)<>-1) Then Return
	arraydec1(xt,yt)=array1(xt,yt)
	If xt>1 Then testdec1(xt-2,yt)
	If xt<13 Then testdec1(xt+2,yt)
	If (xt>0) And (yt>0) Then testdec1(xt-1,yt-1)
	If (yt>0) And (xt<14) Then testdec1(xt+1,yt-1)
	If (yt<11) And (xt>0) Then testdec1(xt-1,yt+1)
	If (yt<11) And (xt<14) Then testdec1(xt+1,yt+1)
End Function

;*****************************************************************

Function testdec2(xt,yt)
	If (array2(xt,yt)=-1) Or (arraydec2(xt,yt)<>-1) Then Return
	arraydec2(xt,yt)=array2(xt,yt)
	If xt>1 Then testdec2(xt-2,yt)
	If xt<13 Then testdec2(xt+2,yt)
	If (xt>0) And (yt>0) Then testdec2(xt-1,yt-1)
	If (yt>0) And (xt<14) Then testdec2(xt+1,yt-1)
	If (yt<11) And (xt>0) Then testdec2(xt-1,yt+1)
	If (yt<11) And (xt<14) Then testdec2(xt+1,yt+1)
End Function

;*****************************************************************

Function testdecai(xt,yt)
	If (arrayai(xt,yt)=-1) Or (arraydecai(xt,yt)<>-1) Then Return
	arraydecai(xt,yt)=arrayai(xt,yt)
	If xt>1 Then testdecai(xt-2,yt)
	If xt<13 Then testdecai(xt+2,yt)
	If (xt>0) And (yt>0) Then testdecai(xt-1,yt-1)
	If (yt>0) And (xt<14) Then testdecai(xt+1,yt-1)
	If (yt<11) And (xt>0) Then testdecai(xt-1,yt+1)
	If (yt<11) And (xt<14) Then testdecai(xt+1,yt+1)
End Function

;*****************************************************************

Function addball1(x,y,num)
	array1(x,y)=num
	SetBuffer FrontBuffer()
	DrawImage balls,xpl1+ball_ray_x+x*intervx,ypl1+ball_ray_y+y*intervy,num
	SetBuffer ImageBuffer(bitmap(2))
	DrawImage balls,xpl1+ball_ray_x+x*intervx,ypl1+ball_ray_y+y*intervy,num
	SetBuffer ImageBuffer(mask)
	DrawImage maskballs,xpl1+ball_ray_x+x*intervx,ypl1+ball_ray_y+y*intervy
	SetBuffer BackBuffer()
	DrawImage balls,xpl1+ball_ray_x+x*intervx,ypl1+ball_ray_y+y*intervy,num
End Function

;*****************************************************************

Function addball2(x,y,num)
	array2(x,y)=num
	SetBuffer FrontBuffer()
	DrawImage balls,xpl2+ball_ray_x+x*intervx,ypl2+ball_ray_y+y*intervy,num
	SetBuffer ImageBuffer(bitmap(2))
	DrawImage balls,xpl2+ball_ray_x+x*intervx,ypl2+ball_ray_y+y*intervy,num
	SetBuffer ImageBuffer(mask)
	DrawImage maskballs,xpl2+ball_ray_x+x*intervx,ypl2+ball_ray_y+y*intervy
	SetBuffer BackBuffer()
	DrawImage balls,xpl2+ball_ray_x+x*intervx,ypl2+ball_ray_y+y*intervy,num
End Function

;*****************************************************************

Function draw(n,x,y)
	c$=Str$(n)
	Color 0,0,0
	Rect x-Len(c$)*8,y,Len(c$)*16,17,1
	Color 255,255,255
	Text x,y,c$,True,False
End Function

;*****************************************************************

Function drawstring(String$,x,y)
	Color 0,0,0
	Rect x,y,Len(String$)*17,17,1
	Color 255,255,255
	Text x,y,String$
End Function

;*****************************************************************
Function add_blitlist(handl,x,y,frame)
	liste.blitlist=New blitlist
	liste\handl=handl
	liste\x=x		
	liste\y=y
	liste\frame=frame
	liste\db=0				;first time
End Function

;*****************************************************************
;Simples blits occuring on the two buffers, one at a time
Function blitlist()
	For liste=Each blitlist
		DrawImage liste\handl,liste\x,liste\y,liste\frame
		liste\db=liste\db+1
		If liste\db=2 Then Delete liste						;blit in the two backbuffers? ok destroy the object
	Next
End Function

;*****************************************************************

Function qblit(db,handl,x,y,frame)
	If db=0
		qobjets0.qobjet0=New qobjet0
		qobjets0\x=x-ImageXHandle(handl)
		qobjets0\y=y-ImageYHandle(handl)
		qobjets0\w=ImageWidth(handl)
		qobjets0\h=ImageHeight(handl)	
	Else
		qobjets1.qobjet1=New qobjet1
		qobjets1\x=x-ImageXHandle(handl)
		qobjets1\y=y-ImageYHandle(handl)
		qobjets1\w=ImageWidth(handl)
		qobjets1\h=ImageHeight(handl)
	EndIf
	DrawImage handl,x,y,frame
	
End Function

;*****************************************************************

Function qblit_or(db,handl,x,y,frame)
	If db=0
		qobjets0.qobjet0=New qobjet0
		qobjets0\x=x-ImageXHandle(handl)
		qobjets0\y=y-ImageYHandle(handl)
		qobjets0\w=ImageWidth(handl)
		qobjets0\h=ImageHeight(handl)	
	Else
		qobjets1.qobjet1=New qobjet1
		qobjets1\x=x-ImageXHandle(handl)
		qobjets1\y=y-ImageYHandle(handl)
		qobjets1\w=ImageWidth(handl)
		qobjets1\h=ImageHeight(handl)
	EndIf
	DrawBlock handl,x,y,frame
End Function

;*****************************************************************

Function unqueue(db)
	If db=0
		For qobjets0=Each qobjet0
			DrawBlockRect bitmap(2),qobjets0\x,qobjets0\y,qobjets0\x,qobjets0\y,qobjets0\w,qobjets0\h
		Next
		Delete Each qobjet0
	Else
		For qobjets1=Each qobjet1
			DrawBlockRect bitmap(2),qobjets1\x,qobjets1\y,qobjets1\x,qobjets1\y,qobjets1\w,qobjets1\h
		Next
		Delete Each qobjet1
	EndIf

End Function

;*****************************************************************

Function check(name$)
	If FileType(name$)=0
		Graphics 640,480,16,2
		Color 255,255,255
		Text 320,200,"Unable to load a file !",True,True
		Text 320,220,"Name of this file is :",True,True
		Text 320,240,name$,True,True
		Color 255,0,0
		Text 320,270,"Press a key to exit",True,True
		WaitKey()
		End
	EndIf
End Function

;*****************************************************************

Function loadimg(name$)
	check(name$)
	Return LoadImage(name$)
End Function

;*****************************************************************

Function loadsnd(name$)
	check(name$)
	Return LoadSound(name$)
End Function

;*****************************************************************

Function getarrayai%(x,y)
	If x>=0 And x<=15 And y>=0 And y<=12
;		DrawImage balls,xpl2+x*intervx+ball_width/2,ypl2+y*intervy+ball_height/2,b2
 		If arrayai(x,y)<>-1 Then Return 1;array2(x,y)
	EndIf
End Function

;*****************************************************************
Function tracedirection(db,xpl,ypl,a)
	u=0
	x=(nb_balls_x*ball_width)/2+(36+u)*fsin(a)
	y=2+(nb_balls_y+2)*intervy+(36+u)*fcos(a)

	Repeat

		x=x+pl2_ball_speed*fsin(a)						;next position
		y=y+pl2_ball_speed*fcos(a)

		If x<=ball_ray_x								;bouncing test : left
			x=ball_ray_x
			If a<270
				a=180-(a-180)
			Else
				a=360-a
			EndIf
		EndIf
		If x>=(ball_width*nb_balls_x)-ball_ray_x-1		;right
			x=(ball_width*nb_balls_x)-ball_ray_x-1
			If a<90
				a=360-a
			Else
				a=180+(180-a)
			EndIf
		EndIf

		If (u And 3)=(guide_movement Shr 2) Then qblit(db,guide,x+xpl,y+ypl,0)
		u=u+1
		
	Until y<=ball_ray_y Or ImagesCollide(mask,0,0,0,maskballs,xpl+x,ypl+y,0)=True
End Function

;*****************************************************************

Function ai()

	ptr_ai=0
	result_nb=0

	;Boucle de test de chaque angle
	For i=0 To 19
		;anglelai%=(i*8+Int(2*Rand(-2,2))) Mod 160+100
		anglelai%=(i*8) Mod 160+100

		xbai#=(nb_balls_x*ball_width)/2+36*fsin(anglelai)
		ybai#=2+(nb_balls_y+2)*intervy+36*fcos(anglelai)
		anglebai=anglelai

		For y=0 To 12
			For x=0 To 16
				arrayai(x,y)=array2(x,y)
			Next 
		Next
	
		numbai=numb2-1											;next ball to pick number
		bai=ballslaunched(numbai)
		
		; Petites initialisations
		releasebai=False
		nbsameballsai=0 : exploseai=False
		stackbai=0 : effectivestackbai=0 : looseai=False : nbstackai=0
		posxchuteai=0
		Delete Each ballai
		Delete Each falling_ballai
		Delete Each climbing_ballai
		compte_rebonds=0

		;Boucle d'move de la ball tire
		oldxt=0
		oldyt=0
	
		Repeat
			xbai=xbai+plai_ball_speed*fsin(anglebai)			;move ball
			ybai=ybai+plai_ball_speed*fcos(anglebai)
		
			If xbai<=ball_ray_x									;bounce test : left
				xbai=ball_ray_x
				compte_rebonds=compte_rebonds+1
				If anglebai<270
					anglebai=180-(anglebai-180)
				Else
					anglebai=360-anglebai
				EndIf
			EndIf
			If xbai>=(ball_width*nb_balls_x)-ball_ray_x-1		;right
				xbai=(ball_width*nb_balls_x)-ball_ray_x-1
				compte_rebonds=compte_rebonds+1
				If anglebai<90
					anglebai=360-anglebai
				Else
					anglebai=180+(180-anglebai)
				EndIf
			EndIf
		
			oldxt=xt
			oldyt=yt
			yt=ybai;-(ball_height-intervy)/2						;for integer conversion
			yt=Int(yt/intervy)

			If (yt And 1)=0
				xt=xbai
				xt=Int(xt/ball_width)
				xt=xt+xt
			Else
				xt=xbai-intervx
				xt=Int(xt/ball_width)
				xt=xt+xt
				xt=xt+1
			EndIf
			
			hit=0
			xmid%=xt*intervx+ball_width/2
			ymid%=yt*intervy+ball_height/2;intervy/2
			
			;testing balls in this quadrant
			difx=xbai-xmid
			dify=ybai-ymid
			
			;not used
			;Gosub avoid_calc

		Until (ImagesCollide(mask,0,0,0,maskballs,xpl2+xbai,ypl2+ybai,0)=True) Or (ybai<=ball_ray_y)	 ;test collision autres balls
		
;		Until (hit<>0) Or (ybai<=ball_ray_y)	 ;collision test for others balls

		;*****
;		SetBuffer BackBuffer()
;		Color 255,0,0
;		results_ai(result_nb,2)=xpl2+xmid-8
;		results_ai(result_nb,3)=ypl2+ymid-8
;		Oval xpl2+xmid-8,ypl2+ymid-8,16,16,1
;		SetBuffer FrontBuffer()
;		Color 255,0,0
;		Oval xpl2+xmid-8,ypl2+ymid-8,16,16,1
		;*****

		If arrayai(xt,yt)<0
			Delete Each ballai
			arrayai(xt,yt)=bai
			nbsameballsai=0
			testarrayai(xt,yt)							;testing same balls
			If nbsameballsai>=3 Then 
				;test_decrocheai
				For y=0 To 12
					For x=0 To 14 Step 2
						arraydecai(x,y)=-1
						arraydecai(x+1,y)=-1
					Next 
				Next 
				For x=0 To 14 Step 2					 ;testing all hooked ball from the first line
					If (arrayai(x,0)<>-1) And (arraydecai(x,0)=-1) Then testdecai(x,0)
				Next 
			
				For y=0 To 12
					For x=0 To 14 Step 2
						If (y And 1)=0
							If (arrayai(x,y)<>-1) And (arraydecai(x,y)=-1)
								sameai.ballai=New ballai
								sameai\x=x
								sameai\y=y
								sameai\num=arrayai(x,y)
								arrayai(x,y)=-1
								nbsameballsai=nbsameballsai+1
							EndIf
						Else
							If x<>14
								If (arrayai(x+1,y)<>-1) And (arraydecai(x+1,y)=-1)
									sameai.ballai=New ballai
									sameai\x=x+1
									sameai\y=y
									sameai\num=arrayai(x+1,y)
									arrayai(x+1,y)=-1
									nbsameballsai=nbsameballsai+1
								EndIf
							EndIf
						EndIf
						arraydecai(x,y)=-1
						arraydecai(x+1,y)=-1
					Next 
				Next 
	
;				stackb1=stackb1+nbsameballs2-3
			EndIf
			sameai=First ballai
		EndIf

;		releasebai=False
;		bai=nextbai
;		numbai=numbai+1
;		nextbai=ballslaunched(numbai)
	
		;replace the launched ball (and the eventual identical one) that was removed in the testarray proc and test if it isn't under the level
		If nbsameballsai<3
			If sameai<>Null 
				If sameai\y>=11 Then looseai=True
				arrayai(sameai\x,sameai\y)=sameai\num
				sameai=After sameai
				If sameai<>Null 
					If sameai\y>=11 Then looseai=True
					arrayai(sameai\x,sameai\y)=sameai\num
				EndIf
			EndIf
		EndIf
		
;Stop
		;Result of this angle test in the array
		results_ai(i,0)=anglelai
		results_ai(i,1)=nbsameballsai
;		results_ai(i,2)=xt
;		results_ai(i,3)=yt
		results_ai(i,4)=compte_rebonds
		If yt>=11 Or looseai Then results_ai(i,1)=-1

		result_nb=result_nb+1
	Next

	max=-1
	compte_rebonds=0
	nb=0

	For i=0 To 19
		If results_ai(i,1)>=max
			If results_ai(i,1)=max
				If results_ai(i,4)<compte_rebonds
					max=results_ai(i,1)
					compte_rebonds=results_ai(i,4)
					nb=i
				EndIf
			Else
				max=results_ai(i,1)
				compte_rebonds=results_ai(i,4)
				nb=i
			EndIf
		EndIf
	Next

	;*****
;	xmid%=results_ai(nb,2)*intervx+ball_width/2
;	ymid%=results_ai(nb,3)*intervy+ball_height/2;intervy/2

;	SetBuffer BackBuffer()
;	Color 255,255,0
;	Oval xpl2+xmid,ypl2+ymid,16,16,1
;	SetBuffer FrontBuffer()
;	Color 255,255,0
;	Oval xpl2+xmid,ypl2+ymid,16,16,1
	;*****

;	Stop

	Return results_ai(nb,0)

End Function

Function prout()
		ptr_ai=0
		For y=0 To 12
			For x=0 To 16
				PokeByte mem_ai,ptr_ai,arrayai(x,y)
				ptr_ai=ptr_ai+1
			Next 
		Next 
End Function

;********************************************************************************************************

If GfxModeExists (800,600,16)
	Graphics 800,600,16
Else
	Graphics 800,600,16,2
EndIf

.start
Gosub init_vars
Gosub accueil
Gosub loading
Gosub create_clearingshapes
Gosub get_timing
Gosub init_screen
Gosub new_arrays
Gosub draw_balls
If music Then musique=PlayMusic("snd\fullcontact.mod")
If Not musique Then music=False

;*****************************************************************
.two_players_game_start
xb1=(nb_balls_x*ball_width)/2+xpl1: yb1=(nb_balls_y+2)*intervy+ypl1: anglel1=180 : angleb1=180 : releaseb1=False : key1=0
xb2=(nb_balls_x*ball_width)/2+xpl2: yb2=(nb_balls_y+2)*intervy+ypl : anglel2=180 : angleb2=180 : releaseb2=False : key2=0
numb1=0 : nbsameballs1=0 : explose1=False
numb2=0 : nbsameballs2=0 : explose2=False
compte1=0 : compte2=0
b1=ballslaunched(numb1)
b2=ballslaunched(numb2)
boom=0

stackb1=0 : effectivestackb1=0 : loose1=False : nbstack1=0
stackb2=0 : effectivestackb2=0 : loose2=False : nbstack2=0
posxchute1=0 : posxchute2=0
db=0
rw50=False : rw54=False	: rw42=False				; not repetitive keys

angle_rec=180
uncount=200-Rand((niveau+1)*10,200)
If uncount<1 Then uncount=1
If uncount>200 Then uncount=200

Delete Each ball1
Delete Each falling_ball1
Delete Each climbing_ball1
Delete Each ball2
Delete Each falling_ball2
Delete Each climbing_ball2

Gosub nextball1
Gosub nextball2

main_timer=CreateTimer(60)

FlushKeys()
FlushMouse()

Repeat

;debug test pour passer d'un niveau  l'autre en appuyant sur tab
;If KeyHit(15)
;loose2=True
;EndIf

	main_frames=WaitTimer(main_timer) ;how many times should we update?
	For k=1 To main_frames

;		If loose1 Or loose2 Then Goto new_level
	
		blitlist()										;draw simples blits in the backbuffers (one at a  time)
		unqueue(db)										; clear from bitmap 2
	
	;	DrawImage mask,0,0
	
		Gosub draw_fleches
		Gosub get_keys
	
		If option_trace=True
			guide_movement=(guide_movement+1) And 15
			tracedirection(db,xpl1,ypl1,anglel1)
			tracedirection(db,xpl2,ypl2,anglel2)
		EndIf

		If releaseb1=False								;if the ball isn't launched yet
			If nbsameballs1>0 Or explose1=True			;moving balls (one each sync to enhance visual)
				If nbsameballs1<3
					Gosub pl1_create_sticking_balls		;sticking balls (with the launched ones)
				Else
					Gosub pl1_create_fallings_balls		;balls from explosion
				EndIf
				If explose1 Then Gosub pl1_fallings_balls
			Else
				qblit(db,balls,(nb_balls_x*ball_width)/2+xpl1+36*fsin(anglel1),2+(nb_balls_y+2)*intervy+ypl1+36*fcos(anglel1),b1)	;l'draw sur son socle
				compte1=compte1+1						;launch ball after a little delay
				If (compte1=450 Or compte1=400 Or compte1=350 Or compte1=300) Then sonplayer1=PlaySound(sons(4))	;last seconds "tick"
				If (fire1 Or compte1>=500) And nbstack1=0	 ;nbstack is used to avoid ball launching while falls
					If compte1<500 Then rw42=True
					compte1=0
					releaseb1=True
					angleb1=anglel1
					xb1=(nb_balls_x*ball_width)/2+36*fsin(anglel1)
					yb1=2+(nb_balls_y+2)*intervy+36*fcos(anglel1)
					sonplayer1=PlaySound(sons(3))
				EndIf
			EndIf
		Else
			Gosub pl1_deplace_ball
			If (ImagesCollide(mask,0,0,0,maskballs,xpl1+xb1,ypl1+yb1,0)=True) Or (yb1<=ball_ray_y)	 ;test collision autres balls
				Gosub pl1_gere_collision
			Else
				qblit(db,balls,xpl1+xb1,ypl1+yb1,b1)	;draw ball
			EndIf
		EndIf
	
	;*****************************************************************
	
		If releaseb2=False
			If nbsameballs2>0 Or explose2=True
				If nbsameballs2<3
					Gosub pl2_create_sticking_balls
				Else
					Gosub pl2_create_fallings_balls
				EndIf
				If explose2 Then Gosub pl2_fallings_balls
			Else
				qblit(db,balls,(nb_balls_x*ball_width)/2+xpl2+36*fsin(anglel2),2+(nb_balls_y+2)*intervy+ypl2+36*fcos(anglel2),b2)
				compte2=compte2+1
				If (compte2=450 Or compte2=400 Or compte2=350 Or compte2=300) Then sonplayer2=PlaySound(sons(4))
				If (fire2 Or compte2>=500) And nbstack2=0
					If compte2<500 Then rw54=True
					compte2=0
					releaseb2=True
					angleb2=anglel2
					xb2=(nb_balls_x*ball_width)/2+36*fsin(anglel2)
					yb2=2+(nb_balls_y+2)*intervy+36*fcos(anglel2)
					sonplayer2=PlaySound(sons(3))
				EndIf
			EndIf
			If computer=True And decision=False
				If uncount<=0									;take decision after a while
					angle_rec=ai()
					decision=True
					uncount=computer_difficulty(niveau,1)+Rand(computer_difficulty(i,2))-Rand(computer_difficulty(i,2))
					If uncount<1 Then uncount=1
					If uncount>200 Then uncount=200
				Else
					uncount=uncount-1
				EndIf
			EndIf
		Else
			Gosub pl2_deplace_ball
			If (ImagesCollide(mask,0,0,0,maskballs,xpl2+xb2,ypl2+yb2,0)=True) Or (yb2<=ball_ray_y)	 ;test collision autres balls
				Gosub pl2_gere_collision
			Else
				qblit(db,balls,xpl2+xb2,ypl2+yb2,b2)
			EndIf
		EndIf
	
		Gosub pl1_draw_climbing_balls						;beware of the order!!!
		Gosub pl2_draw_climbing_balls
		If same1=Null Then Gosub pl1_create_climbing_balls
		If same2=Null Then Gosub pl2_create_climbing_balls
		Gosub draw_scores	
	
		If option_boom Then Gosub boom						;scroll following explosion
	
		Gosub flying_logo
		
	Next 
	Flip True
	db=1-db
	SetBuffer BackBuffer()

	
Until KeyDown(1)=True Or loose1 Or loose2

;Last cleaning
blitlist()
unqueue(db)	
Flip True
db=1-db
SetBuffer BackBuffer()
blitlist()
unqueue(db)	

If loose1=True 
	If computer=True Then computer_won_games=computer_won_games+1
	score2=score2+100
	Gosub player2_winner
EndIf
If loose2=True 
	If computer=True Then player_won_games=player_won_games+1
	score1=score1+100
	Gosub player1_winner
EndIf

FreeImage bitmap(0)
FreeImage bitmap(2)
FreeImage mask
FreeTimer(main_timer)

If loose1 Or loose2
	niveau=niveau+1
	If computer=True
		If player_won_games>=3 Or computer_won_games>=3
			computer_level=computer_level+1
			If computer_level>=10
				Gosub game_winner_screen
				Goto loose_or_win
			EndIf
			If player_won_games>computer_won_games 
				Gosub winner_screen
				niveau=computer_level*5
			Else
				Gosub looser_screen
				Goto loose_or_win
			EndIf
			player_won_games=0
			computer_won_games=0
		EndIf
	EndIf
	Gosub new_level
	Goto two_players_game_start
EndIf

.loose_or_win



;ferme le fichier des niveaux
CloseFile levels

If computer=True Then Gosub check_highscores
Goto start

FreeFont fntArial
;FreeBank mem_ai

;**
;For aa.l=0 To 63
;	VWait
;	TrackerVolume 63-aa
;	FadePalette 0,1,1-aa/64
;	DisplayPalette 0,1
;Next aa




End


;*****************************************************************
.winner_screen
	ClsColor 0,0,0
	Cls
	Color 255,255,255
	FlushKeys
	Text 0,0,"Bobble Puzzle "+version$+" (look for new versions on http://djes.free.fr)"
	Text 0,20,"By Jsahel Benoist (djes@free.fr)"
	Text 400,580,"Press a key to continue",True,True
	Text 400,120,"LEVEL COMPLETED !",True,True
	Text 400,200,"Score : "+Str$(score1),True,True 
	Text 400,215,"Next level : "+Str$(computer_level+1),True,True
	Flip
	WaitKey
	Return

;*****************************************************************
.game_winner_screen
	ClsColor 0,0,0
	Cls
	Color 255,255,255
	FlushKeys
	Text 0,0,"Bobble Puzzle "+version$+" (look for new versions on http://djes.free.fr)"
	Text 0,20,"By Jsahel Benoist (djes@free.fr)"
	Text 400,580,"Press a key to continue",True,True
	Text 400,120,"WINNER !!!",True,True
	Text 400,200,"Score : "+Str$(score1),True,True 
	Text 400,265,"Congratulations !!!",True,True
	Flip
	WaitKey
	Return

;*****************************************************************
.looser_screen
	ClsColor 0,0,0
	Cls
	Color 255,255,255
	FlushKeys
	Text 0,0,"Bobble Puzzle "+version$+" (look for new versions on http://djes.free.fr)"
	Text 0,20,"By Jsahel Benoist (djes@free.fr)"
	Text 400,580,"Press a key to continue",True,True
	Text 400,120,"LOOSER !",True,True
	Text 400,200,"Score : "+Str$(score1),True,True 
	Text 400,215,"Level : "+Str$(computer_level),True,True 
	Text 400,265,"Try again !!!",True,True
	Flip
	WaitKey
	Return

;*****************************************************************
.player2_winner
	i=-300
	timer=CreateTimer(60)
	While i<=300
		frames=WaitTimer(timer) ;how many times should we update?
		For k=1 To frames
			i=i+30
		Next
		Flip True
		db=1-db
		SetBuffer BackBuffer()
		unqueue(db)										; clean from bitmap 2
		qblit(db,winner,600,i,0)
	Wend
	boom=2880 : ampli#=180.0 : SoundPitch sons(1),5000 : vol=30
	SoundVolume sons(1),vol/64
	sonplayer1=PlaySound(sons(1))
	oldtime=MilliSecs()-1
	FreeTimer(timer)
	timer=CreateTimer(60)
	i=0
	While i<240
		frames=WaitTimer(timer) ;how many times should we update?
		For k=1 To frames
			i=i+1
			If ampli#>0
				dddd=ampli#*Sin(boom)
				boom=boom-8
				ampli#=ampli#/1.022
			EndIf
		Next
		Flip True
		SetBuffer BackBuffer()
		unqueue(db)										; clean from bitmap 2
		If boom>0
			GrabImage bitmap(1),0,dddd
			qblit_or(db,bitmap(1),0,0,0)
			Color 0,0,0
		;	If dddd<>0
				If dddd<0
					Rect 0,0,800,-dddd,1
				Else
					Rect 0,600-dddd,800,dddd,1
				EndIf
		;	EndIf
		EndIf	 
		qblit(db,winner,600,300,0)
	Wend
	FreeTimer(timer)
	FlushKeys()
	Return


;*****************************************************************
.player1_winner
	i=-300
	timer=CreateTimer(60)
	While i<=300
		frames=WaitTimer(timer) ;how many times should we update?
		For k=1 To frames
			i=i+30
		Next
		Flip True
		db=1-db
		SetBuffer BackBuffer()
		unqueue(db)										; clean from bitmap 2
		qblit(db,winner,200,i,0)
	Wend
	boom=2880 : ampli#=180.0 : SoundPitch sons(1),5000 : vol=30
	SoundVolume sons(1),vol/64
	sonplayer1=PlaySound(sons(1))
	oldtime=MilliSecs()-1
	FreeTimer(timer)
	timer=CreateTimer(60)
	i=0
	While i<240
		frames=WaitTimer(timer) ;how many times should we update?
		For k=1 To frames
			i=i+1
			If ampli#>0
				dddd=ampli#*Sin(boom)
				boom=boom-8
				ampli#=ampli#/1.022
			EndIf
		Next
		Flip True
		SetBuffer BackBuffer()
		unqueue(db)										; clean from bitmap 2
		If boom>0
			GrabImage bitmap(1),0,dddd
			qblit_or(db,bitmap(1),0,0,0)
			Color 0,0,0
		;	If dddd<>0
				If dddd<0
					Rect 0,0,800,-dddd,1
				Else
					Rect 0,600-dddd,800,dddd,1
				EndIf
		;	EndIf
		EndIf	 
		qblit(db,winner,200,300,0)
	Wend
	FreeTimer(timer)
	FlushKeys()
	Return

;*****************************************************************
.draw_fleches
	qblit(db,fleches,(nb_balls_x*ball_width)/2+xpl1,(nb_balls_y+2)*intervy+ypl1+10,(259-anglel1) Shr 1)	;draw les flches
	qblit(db,fleches,(nb_balls_x*ball_width)/2+xpl2,(nb_balls_y+2)*intervy+ypl2+10,(259-anglel2) Shr 1)
	Return

;*****************************************************************
.flying_logo
	posflyinglogo=posflyinglogo-5
	qblit(db,flyinglogo(0),400+60*Sin(posflyinglogo),80+60*Cos(posflyinglogo),0)
	qblit(db,flyinglogo(1),400+60*Sin(posflyinglogo+20),80+60*Cos(posflyinglogo+20),0)
	qblit(db,flyinglogo(2),400+60*Sin(posflyinglogo+40),80+60*Cos(posflyinglogo+40),0)
	qblit(db,flyinglogo(3),400+60*Sin(posflyinglogo+60),80+60*Cos(posflyinglogo+60),0)
	qblit(db,flyinglogo(4),400+60*Sin(posflyinglogo+80),80+60*Cos(posflyinglogo+80),0)
	qblit(db,flyinglogo(5),400+60*Sin(posflyinglogo+100),80+60*Cos(posflyinglogo+100),0)
	qblit(db,flyinglogo(6),400+60*Sin(posflyinglogo+140),80+60*Cos(posflyinglogo+140),0)
	qblit(db,flyinglogo(7),400+60*Sin(posflyinglogo+160),80+60*Cos(posflyinglogo+160),0)
	qblit(db,flyinglogo(8),400+60*Sin(posflyinglogo+180),80+60*Cos(posflyinglogo+180),0)
	qblit(db,flyinglogo(9),400+60*Sin(posflyinglogo+200),80+60*Cos(posflyinglogo+200),0)
	qblit(db,flyinglogo(10),400+60*Sin(posflyinglogo+220),80+60*Cos(posflyinglogo+220),0)
	qblit(db,flyinglogo(11),400+60*Sin(posflyinglogo+240),80+60*Cos(posflyinglogo+240),0)
	Return

;*****************************************************************
.draw_scores
	Color 229,19,44
;	drawstring("Stack",60,6)  : drawstring("Score",270,6)
;	drawstring("Stack",460,6) : drawstring("Score",670,6)
	draw(stackb1,130,5)	:	draw(score1,360,5)
	draw(stackb2,530,5)	:	draw(score2,760,5)	
	Return	

;*****************************************************************
.pl1_gere_collision
	yt=yb1									;for integer conversion
	yt=yt/intervy
	If (yt And 1)=0
		x=xb1								;for integer conversion
		x=(x/ball_width)*ball_width
		;x=(x/16)*16
	Else
		x=xb1								;for integer conversion
		x=((x-intervx)/ball_width)*ball_width+intervx
		;x=((x-8)/16)*16+8
	EndIf
	xt=x/intervx
	If array1(xt,yt)<0
		Delete Each ball1					;reinitialiase le arrayleau des balls identiques ( faire tomber) 
		array1(xt,yt)=b1						;place notre ball
		nbsameballs1=0
		testarray1(xt,yt)
		If nbsameballs1>=3 Then Gosub pl1_nouvelle_explosion
		same1=First ball1
	EndIf
	releaseb1=False
	b1=nextb1
	Gosub nextball1
	xb1=64 : yb1=182
	nbstack1=nbstack1+stackb1
	effectivestackb1=effectivestackb1+stackb1
	stackb1=0
	Gosub draw_scores
	Return

;*****************************************************************
.pl2_gere_collision

;	yt=yb2-(ball_height-intervy)/2									;for integer conversion
;	yt=Int(yt/intervy)
;	If (yt And 1)=0
;		xt=xb2
;		xt=Int(xt/ball_width)
;		xt=xt+xt
;	Else
;		xt=xb2-intervx
;		xt=Int(xt/ball_width)
;		xt=xt+xt
;		xt=xt+1
;	EndIf

	yt=yb2									;for integer conversion
	yt=yt/intervy
	If (yt And 1)=0
		x=xb2								;for integer conversion
		x=(x/ball_width)*ball_width
		;x=(x/16)*16
	Else
		x=xb2								;for integer conversion
		x=((x-intervx)/ball_width)*ball_width+intervx
		;x=((x-8)/16)*16+8
	EndIf
	xt=x/intervx

	If array2(xt,yt)<0
		Delete Each ball2
		array2(xt,yt)=b2
		nbsameballs2=0
		testarray2(xt,yt)
		If nbsameballs2>=3 Then Gosub pl2_nouvelle_explosion
		same2=First ball2
	EndIf
	releaseb2=False
	b2=nextb2
	Gosub nextball2
	xb2=64 : yb2=182
	nbstack2=nbstack2+stackb2
	effectivestackb2=effectivestackb2+stackb2
	stackb2=0
	Gosub draw_scores	
	Return

;*****************************************************************
.pl1_nouvelle_explosion
	SoundPitch sons(1),20000 : vol=10
	If nbsameballs1>=4 : score1=score1+1 : boom=720 : ampli=40 : SoundPitch sons(1),8000 : vol=15 :	EndIf
	If nbsameballs1>=7 : score1=score1+2 : boom=1440 : ampli=30 : SoundPitch sons(1),6000 : vol=30 :	EndIf
	If nbsameballs1>=10 : score1=score1+5 : boom=2880 : ampli=20 : SoundPitch sons(1),3000 : vol=64 :	EndIf
	SoundVolume sons(1),vol/64
	sonplayer1=PlaySound(sons(1))
	Gosub test_decroche1
	stackb2=stackb2+nbsameballs1-3
	score1=score1+nbsameballs1-3
	Gosub draw_scores
	Return

;*****************************************************************
.pl2_nouvelle_explosion
	SoundPitch sons(1),20000 : vol=10
	If nbsameballs2>=4 : score1=score1+1 : boom=720 : ampli=40 : SoundPitch sons(1),8000 : vol=15 :	EndIf
	If nbsameballs2>=7 : score2=score2+2 : boom=1440 : ampli=30 : SoundPitch sons(1),6000 : vol=30 :	EndIf
	If nbsameballs2>=10 : score2=score2+5 : boom=2880 : ampli=20 : SoundPitch sons(1),3000 : vol=64 :	EndIf
	SoundVolume sons(1),vol/64
	sonplayer2=PlaySound(sons(1))
	Gosub test_decroche2
	stackb1=stackb1+nbsameballs2-3
	score2=score2+nbsameballs2-3
	Gosub draw_scores
	Return

;*****************************************************************
.pl1_deplace_ball
	xb1=xb1+pl1_ball_speed*fsin(angleb1)			;move the ball
	yb1=yb1+pl1_ball_speed*fcos(angleb1)
	If xb1<=ball_ray_x								;test rebonds : left
		sonplayer1=PlaySound(sons(0))
		xb1=ball_ray_x+(ball_ray_x-xb1)
		If angleb1<270
			angleb1=180-(angleb1-180)
		Else
			angleb1=360-angleb1
		EndIf
	EndIf
	Right=(ball_width*nb_balls_x)-ball_ray_x-1
	If xb1>=Right										;right
		sonplayer1=PlaySound(sons(0))
		xb1=Right-(xb1-Right)
		If angleb1<90
			angleb1=360-angleb1
		Else
			angleb1=180+(180-angleb1)
		EndIf
	EndIf
	Return

;*****************************************************************
.pl2_deplace_ball
	xb2=xb2+pl2_ball_speed*fsin(angleb2)			;move the ball
	yb2=yb2+pl2_ball_speed*fcos(angleb2)
	If xb2<=ball_ray_x								;test rebonds : left
		sonplayer2=PlaySound(sons(0))
		xb2=ball_ray_x
		If angleb2<270
			angleb2=180-(angleb2-180)
		Else
			angleb2=360-angleb2
		EndIf
	EndIf
	If xb2>=(ball_width*nb_balls_x)-ball_ray_x-1			;right
		sonplayer2=PlaySound(sons(0))
		xb2=(ball_width*nb_balls_x)-ball_ray_x-1
		If angleb2<90
			angleb2=360-angleb2
		Else
			angleb2=180+(180-angleb2)
		EndIf
	EndIf
	Return

;*****************************************************************
.pl1_fallings_balls
	explode1=First falling_ball1
	For explode1=Each falling_ball1				;draw chaque ball qui tombe
		qblit(db,balls,explode1\x,explode1\y,explode1\num)
		explode1\x=explode1\x+explode1\vitx : explode1\y=explode1\y+explode1\vit : explode1\vit=explode1\vit+1
		If explode1\vit>=(ball_height-1) Then explode1\vit=(ball_height-1)
		If explode1\y>560
			nbsameballs1=nbsameballs1-1
			Delete explode1							;la dtruit quand elle est tombe
		EndIf
	Next
	If nbsameballs1<=0
		Delete Each falling_ball1
		explose1=False
	EndIf
	Return

;*****************************************************************
.pl2_fallings_balls
	explode2=First falling_ball2
	For explode2=Each falling_ball2
		qblit(db,balls,explode2\x,explode2\y,explode2\num)
		explode2\x=explode2\x+explode2\vitx : explode2\y=explode2\y+explode2\vit : explode2\vit=explode2\vit+1
		If explode2\vit>=(ball_height-1) Then explode2\vit=(ball_height-1) 
		If explode2\y>560
			nbsameballs2=nbsameballs2-1
			Delete explode2
		EndIf
	Next
	If nbsameballs2<=0
		Delete Each falling_ball2
		explose2=False
	EndIf
	Return

;*****************************************************************
.pl1_create_fallings_balls
	If same1<>Null
		explode1.falling_ball1=New falling_ball1
		x=same1\x*intervx+xpl1+ball_ray_x : y=same1\y*intervy+ypl1+ball_ray_y
		explode1\x=x
		explode1\y=y
		explode1\num=same1\num
		explode1\vit=-Rnd(4,10)
		explode1\vitx=Rnd(-1,1)
		add_blitlist(shapes,x,y,same1\y*15+same1\x)	;move the balls
		SetBuffer ImageBuffer(bitmap(2))
		DrawImage shapes,x,y,same1\y*15+same1\x		;move the balls
		SetBuffer ImageBuffer(mask)
		DrawImage negative_balls_mask,x,y			;also in mask
		SetBuffer BackBuffer()
		explose1=True
		same1=After same1							;next ball in next loop
	EndIf
	Return

;*****************************************************************
.pl2_create_fallings_balls
	If same2<>Null
		explode2.falling_ball2=New falling_ball2
		x=same2\x*intervx+xpl2+ball_ray_x : y=same2\y*intervy+ypl2+ball_ray_y
		explode2\x=x
		explode2\y=y
		explode2\num=same2\num
		explode2\vit=-Rnd(4,10)
		explode2\vitx=Rnd(-1,1)
		add_blitlist(shapes,x,y,same2\y*15+same2\x)
		SetBuffer ImageBuffer(bitmap(2))
		DrawImage shapes,x,y,same2\y*15+same2\x		;move the balls
		SetBuffer ImageBuffer(mask)
		DrawImage negative_balls_mask,x,y			;also in mask
		SetBuffer BackBuffer()
		explose2=True
		same2=After same2							;next ball in next loop
	EndIf
	Return

;*****************************************************************
;* Lorsque le joueur envoie sa ball
;* la liste same est cre avec les balls identiques, le arrayleau
;* en est affect.
;* Si il y a moins de 3 balls identiques, on draw notre ball
;* on passe en revue les autres eventuelles identiques pour refaire 
;* le arrayleau 
.pl1_create_sticking_balls
	If same1<>Null
		addball1(same1\x,same1\y,same1\num)			;draw sticking balls;
		If same1\y>=11 Then loose1=True
		same1=After same1
		If same1<>Null 
			array1(same1\x,same1\y)=same1\num
			If same1\y>=11 Then loose1=True
			same1=After same1						;next ball in next loop
		EndIf
		sonplayer1=PlaySound(sons(2))
		nbsameballs1=0
	EndIf
	Return

;*****************************************************************
.pl2_create_sticking_balls
	If same2<>Null 
		addball2(same2\x,same2\y,same2\num)
		If same2\y>=11 Then loose2=True
		same2=After same2
		If same2<>Null 
			array2(same2\x,same2\y)=same2\num
			If same2\y>=11 Then loose2=True
			same2=After same2						;next ball in next loop
		EndIf
		sonplayer2=PlaySound(sons(2))
		nbsameballs2=0
	EndIf
	Return

;*****************************************************************
.pl1_create_climbing_balls							;balls envoyees par l'adversaire: creation (db est un petit ralentisseur)
	If effectivestackb1>0 And db=0					;effectivestack n'est incrment que quand the ball qu'on envoie se colle
		stack1.climbing_ball1=New climbing_ball1
		stack1\x=xfalling(posxchute1)
		stack1\y=520
		stack1\num=Rand(0,7)
		stack1\vit=-13								;la vitesse permet  deux balls d'tre spares puisqu'elles ne sont envoyes qu'une frame sur 2
		effectivestackb1=effectivestackb1-1
		posxchute1=(posxchute1+1) Mod 1000
	EndIf
	Return
 
;*****************************************************************
.pl2_create_climbing_balls
	If effectivestackb2>0 And db=0
		stack2.climbing_ball2=New climbing_ball2
		stack2\x=xfalling(posxchute2)
		stack2\y=520
		stack2\num=Rand(0,7)
		stack2\vit=-13
		effectivestackb2=effectivestackb2-1
		posxchute2=(posxchute2+1) Mod 1000
	EndIf
	Return
	
;*****************************************************************
.pl1_draw_climbing_balls	
	stack1.climbing_ball1=First climbing_ball1
	For stack1.climbing_ball1=Each climbing_ball1	;screen
		x=stack1\x : y=stack1\y
		stack1\y=stack1\y+stack1\vit : If stack1\y<=ball_ray_y Then stack1\y=ball_ray_y
		If (ImagesCollide(mask,0,0,0,maskballs,xpl1+x,ypl1+y,0)=True) Or (stack1\y<=ball_ray_y)
			yt=y									;for integer conversion
			yt=yt/intervy
			If (yt And 1)=0
				x=(x/ball_width)*ball_width
;				x=(x/16)*16
			Else
				x=((x-intervx)/ball_width)*ball_width+intervx
;				x=((x-8)/16)*16+8
			EndIf
			xt=x/intervx ;Shr 3;/8
			If loose1=False Then addball1(xt,yt,stack1\num)
			sonplayer1=PlaySound(sons(2))
			If yt>=11 Then loose1=True
			Delete stack1
			nbstack1=nbstack1-1
		Else
			qblit(db,balls,x+xpl1,y+ypl1,stack1\num)
		EndIf
	Next
	Return

;*****************************************************************
.pl2_draw_climbing_balls
	stack2.climbing_ball2=First climbing_ball2
	For stack2.climbing_ball2=Each climbing_ball2
		x=stack2\x : y=stack2\y
		stack2\y=stack2\y+stack2\vit : If stack2\y<=ball_ray_y Then stack2\y=ball_ray_y
		If (ImagesCollide(mask,0,0,0,maskballs,xpl2+x,ypl2+y,0)=True) Or (stack2\y<=ball_ray_y)
			yt=y												;for integer conversion
			yt=yt/intervy
			If (yt And 1)=0
				x=(x/ball_width)*ball_width
;				x=(x/16)*16
			Else
				x=((x-intervx)/ball_width)*ball_width+intervx
;				x=((x-8)/16)*16+8
			EndIf
			xt=x/intervx; Shr 3;/8
			If loose1=False Then addball2(xt,yt,stack2\num)
			sonplayer2=PlaySound(sons(2))
			If yt>=11 Then loose2=True
			Delete stack2
			nbstack2=nbstack2-1
		Else
			qblit(db,balls,x+xpl2,y+ypl2,stack2\num)
		EndIf
	Next
	Return

;*****************************************************************
.get_keys
	If KeyDown(k_pl1_fire)=False And KeyDown(k_pl1_fire2)=False Then rw42=False	; to be sure that player doesn't press anymore
	If KeyDown(k_pl2_fire)=False And KeyDown(k_pl2_fire2)=False Then rw54=False
	If KeyDown(k_music)=False Then rw50=False

	fire1=False
	fire2=False
	
	If KeyDown(k_pause)								;pause
		Repeat
			main_frames=WaitTimer(main_timer)
		Until KeyDown(k_pause)=False
		Repeat
			main_frames=WaitTimer(main_timer)
		Until KeyDown(k_pause)=True
		Repeat
			main_frames=WaitTimer(main_timer)
		Until KeyDown(k_pause)=False
	EndIf

	If GetKey()=k_music And rw50=False	 			;music on/off
		rw50=True
		If music=False 
			ResumeChannel musique
			music=True
		Else
			PauseChannel musique
			music=False
		EndIf
	EndIf

	If KeyHit(68) Then option_boom=Not option_boom	;F10 : boom yes/no
	If KeyHit(67) Then option_trace=Not option_trace	;F9 : trace directions

	If computer=True 
		;one player, can play with arrows keys or c and v
		If ((KeyDown(k_pl1_fire) Or KeyDown(k_pl1_fire2)) And rw42=False) Or ((KeyDown(k_pl2_fire) Or KeyDown(k_pl2_fire2)) And rw54=False) Or JoyHit(1) Or MouseHit(1) Then fire1=True

		;mouse movement?
		mouse_move=MouseXSpeed()
		If mouse_move<>0
			anglel1=((800-MouseX())*160)/800+100
			If anglel1>=259 Then anglel1=259
			If anglel1<=100 Then anglel1=100
		EndIf

		If KeyDown(k_pl1_left) Or KeyDown(k_pl2_left) Or JoyXDir()=-1	;left 1 or 2
			anglel1=anglel1+2
			If anglel1>=259 Then anglel1=259
		EndIf
		If KeyDown(k_pl1_middle) Or KeyDown(k_pl2_middle) Or JoyYDir()=-1	;top 1 or 2
			anglel1=180
		EndIf
		If KeyDown(k_pl1_right)	Or KeyDown(k_pl2_right) Or JoyXDir()=1 ;right 1 or 2
			anglel1=anglel1-2
			If anglel1<=100 Then anglel1=100
		EndIf

		;Gre le dplacement de l'ordi
		If anglel2>angle_rec Then anglel2=anglel2-2
		If anglel2<angle_rec Then anglel2=anglel2+2
		If anglel2=angle_rec And decision=True
			fire2=True
			decision=False
		EndIf
	Else
		If (KeyDown(k_pl1_fire) Or KeyDown(k_pl1_fire2) And rw42=False) Or JoyHit(1,0) Or MouseHit(1) Then fire1=True

		;mouse movement?
		mouse_move=MouseXSpeed()
		If mouse_move<>0
			anglel1=((800-MouseX())*160)/800+100
			If anglel1>=259 Then anglel1=259
			If anglel1<=100 Then anglel1=100
		EndIf

		If KeyDown(k_pl1_left) Or JoyXDir(0)=-1			;left 1
			anglel1=anglel1+2
			If anglel1>=259 Then anglel1=259
		EndIf
		If KeyDown(k_pl1_middle) Or JoyYDir(0)=-1		;top 1
			anglel1=180
		EndIf
		If KeyDown(k_pl1_right) Or JoyXDir(0)=1		;right 1
			anglel1=anglel1-2
			If anglel1<=100 Then anglel1=100
		EndIf
	
		If (KeyDown(k_pl2_fire) Or KeyDown(k_pl2_fire2) And rw54=False) Or JoyHit(1,1) Then fire2=True
		If KeyDown(k_pl2_left) Or JoyXDir(1)=-1								;left 2
			anglel2=anglel2+2
			If anglel2>=259 Then anglel2=259
		EndIf
		If KeyDown(k_pl2_middle) Or JoyYDir(1)=-1						;top 2
			anglel2=180
		EndIf
		If KeyDown(k_pl2_right) Or JoyXDir(1)=-1							;right 2
			anglel2=anglel2-2
			If anglel2<=100 Then anglel2=100
		EndIf
	EndIf
	If KeyDown(59)
		Graphics 800,600,16,1
		niveau=0
;		Restore start_arrays
		Goto start
	EndIf
	If KeyDown(60)
		Graphics 800,600,16,2
		HidePointer
;		MoveMouse 0,0
		niveau=0
		Restore start_arrays
		Goto start
	EndIf
	If KeyDown(61)
		Graphics 800,600,16,3
		HidePointer
;		MoveMouse 0,0
		niveau=0
;		Restore start_arrays
		Goto start
	EndIf
	If KeyDown(62)
		If GfxModeExists(800,600,24)
			Graphics 800,600,24,1
		EndIf
		niveau=0
;		Restore start_arrays
		Goto start
	EndIf
	If KeyDown(63)
		If GfxModeExists(800,600,32)
			Graphics 800,600,32,1
		EndIf
		niveau=0
;		Restore start_arrays
		Goto start
	EndIf
	If KeyDown(64)
		If GfxModeExists(800,600,32)
			Graphics 800,600,32,2
			HidePointer
;			MoveMouse 0,0
		EndIf
		niveau=0
;		Restore start_arrays
		Goto start
	EndIf
	If KeyDown(65)
		If GfxModeExists(800,600,32)
			Graphics 800,600,32,3
			HidePointer
;			MoveMouse 0,0
		EndIf
		niveau=0
;		Restore start_arrays
		Goto start
	EndIf
	If KeyDown(31) Then SaveBuffer(FrontBuffer(),"c:\screenshot.bmp")
	Return


;*****************************************************************
.boom
	If boom>0
		dddd=(boom/ampli)*Sin(boom)
		boom=boom-(ampli/5.0)
		GrabImage bitmap(1),0,dddd
		qblit_or(db,bitmap(1),0,0,0)
		Color 0,0,0
		If dddd<>0
			If dddd<0
				Rect 0,0,800,-dddd,1
			Else
				Rect 0,600-dddd,800,dddd,1
			EndIf
		EndIf
;		boom=boom-1
	EndIf
	Return


;*****************************************************************
.test_decroche1
	For y=0 To 12
		For x=0 To 14 Step 2
			arraydec1(x,y)=-1
			arraydec1(x+1,y)=-1
		Next 
	Next 

	For x=0 To 14 Step 2					 ;testing balls, make not "hooked" ones falling
		If (array1(x,0)<>-1) And (arraydec1(x,0)=-1) Then testdec1(x,0)
	Next

	For y=0 To 12
		For x=0 To 14 Step 2
			If (y And 1)=0
				If (array1(x,y)<>-1) And (arraydec1(x,y)=-1)
					same1.ball1=New ball1
					same1\x=x
					same1\y=y
					same1\num=array1(x,y)
					array1(x,y)=-1
					nbsameballs1=nbsameballs1+1
				EndIf
			Else
				If x<>14
					If (array1(x+1,y)<>-1) And (arraydec1(x+1,y)=-1)
						same1.ball1=New ball1
						same1\x=x+1
						same1\y=y
						same1\num=array1(x+1,y)
						array1(x+1,y)=-1
						nbsameballs1=nbsameballs1+1
					EndIf
				EndIf
			EndIf
			arraydec1(x,y)=-1
			arraydec1(x+1,y)=-1
		Next 
	Next 
	Return

;*****************************************************************
.test_decroche2
	For y=0 To 12
		For x=0 To 14 Step 2
			arraydec2(x,y)=-1
			arraydec2(x+1,y)=-1
		Next 
	Next 
	For x=0 To 14 Step 2					 ;testing "hooked" balls
		If (array2(x,0)<>-1) And (arraydec2(x,0)=-1) Then testdec2(x,0)
	Next 

	For y=0 To 12
		For x=0 To 14 Step 2
			If (y And 1)=0
				If (array2(x,y)<>-1) And (arraydec2(x,y)=-1)
					same2.ball2=New ball2
					same2\x=x
					same2\y=y
					same2\num=array2(x,y)
					array2(x,y)=-1
					nbsameballs2=nbsameballs2+1
				EndIf
			Else
				If x<>14
					If (array2(x+1,y)<>-1) And (arraydec2(x+1,y)=-1)
						same2.ball2=New ball2
						same2\x=x+1
						same2\y=y
						same2\num=array2(x+1,y)
						array2(x+1,y)=-1
						nbsameballs2=nbsameballs2+1
					EndIf
				EndIf
			EndIf
			arraydec2(x,y)=-1
			arraydec2(x+1,y)=-1
		Next 
	Next 
	Return

;*****************************************************************
.nextball1
	numb1=numb1+1
	nextb1=ballslaunched(numb1)
	SetBuffer FrontBuffer()
	DrawImage balls,40,560,nextb1
	SetBuffer ImageBuffer(bitmap(2))
	DrawImage balls,40,560,nextb1
	SetBuffer BackBuffer()
	DrawImage balls,40,560,nextb1
	Return

;*****************************************************************
.nextball2
	numb2=numb2+1
	nextb2=ballslaunched(numb2)
	SetBuffer FrontBuffer()
	DrawImage balls,760,560,nextb2
	SetBuffer ImageBuffer(bitmap(2))
	DrawImage balls,760,560,nextb2
	SetBuffer BackBuffer()
	DrawImage balls,760,560,nextb2
	Return

;*****************************************************************
.loading
	;AMIGA
	;If Exists("boules:fond_128.iff")=False Then End
	;If Exists("boules:gfx_128.iff")=False Then End
	;If Exists("boules:fleches_80_80*64_128.animb")=False Then End
	;If Exists("boules:mask.iff")=False Then End
	;If Exists("boules:boing.snd")=False Then End
	;If Exists("boules:boum.snd")=False Then End
	;If Exists("boules:clac.snd")=False Then End
	;If Exists("boules:lance.snd")=False Then End
	;If Exists("boules:tictac.snd")=False Then End
	;BitMap 0,320,256,7
	;BitMap 1,320,256,7
	;BitMap 2,320,256,7
	;BitMap 3,320,256,7
	;BitMap 4,320,256,7
	;InitPalette 1,256

	fntArial=LoadFont("Arial",17,False,False,False)
	SetFont fntArial

	AutoMidHandle True
	flyinglogo(0)=loadimg("gfx\0100_0b.png")
	flyinglogo(1)=loadimg("gfx\0100_1o.png")
	flyinglogo(2)=loadimg("gfx\0100_2b.png")
	flyinglogo(3)=loadimg("gfx\0100_3b.png")
	flyinglogo(4)=loadimg("gfx\0100_4l.png")
	flyinglogo(5)=loadimg("gfx\0100_5e.png")
	flyinglogo(6)=loadimg("gfx\0100_6p.png")
	flyinglogo(7)=loadimg("gfx\0100_7u.png")
	flyinglogo(8)=loadimg("gfx\0100_8z.png")
	flyinglogo(9)=loadimg("gfx\0100_9z.png")
	flyinglogo(10)=loadimg("gfx\0100_10l.png")
	flyinglogo(11)=loadimg("gfx\0100_11e.png")
	For i=0 To 11
		MaskImage flyinglogo(i),255,255,255
	Next
	winner=loadimg("gfx\0100_winner.png")
	MaskImage winner,255,255,255
	AutoMidHandle False
	bitmap(0)=loadimg("gfx\0100_fond.jpg")
	bitmap(1)=CopyImage(bitmap(0))								;for boom effect
	bitmap(2)=CopyImage(bitmap(0))
	bitmap(4)=CopyImage(bitmap(0))
	check("gfx\0100_boules.png")
	balls=LoadAnimImage("gfx\0100_boules.png",40,40,0,9)
	MidHandle balls
	guide=loadimg("gfx\0100_guide.png")
	MidHandle guide
	MaskImage guide,255,0,255
	maskballs=loadimg("gfx\0100_masque.png")						;ball mask for mask collision ; LoadShape 8,"balls:mask.iff"		
	MidHandle maskballs
	negative_balls_mask=loadimg("gfx\0100_masqueinverse.png")	;to clear the mask 
	MidHandle negative_balls_mask
	MaskImage negative_balls_mask,255,0,255

	check("gfx\0100_fleches.png")
	fleches=LoadAnimImage("gfx\0100_fleches.png",177,129,0,80)	; LoadShape 10,"balls:fleches_80_80*64_128.animb"
	HandleImage fleches,88,98

	mask=CreateImage(800,600)									; BitMap 3,320,256,1 ;mask

	sons(0)=loadsnd("snd\0100_boing.wav")						;	: SetPeriod 0,10
	sons(1)=loadsnd("snd\0100_boum.wav")						;	: SetPeriod 1,1000
	sons(2)=loadsnd("snd\0100_clac.wav")						;	: SetPeriod 2,100
	sons(3)=loadsnd("snd\0100_lance.wav")						;	: SetPeriod 3,50
	sons(4)=loadsnd("snd\0100_tictac.wav")						;	: SetPeriod 4,150

	levels=OpenFile("levels.txt")								;loading levels

	Return

;*****************************************************************
; Create several pictures filled with background
; with a mask
.create_clearingshapes
	shapes=CreateImage(ImageWidth(balls),ImageHeight(balls),12*15)
	temp=CreateImage(ImageWidth(balls),ImageHeight(balls))
	MaskImage balls,255,255,255		;negativise normal mask (last ball is a pink edge)
	Color 0,0,0
	i=0
	For y=0 To 11
		For x=0 To 7
			If (y And 1)=0
				SetBuffer ImageBuffer(bitmap(0))
				GrabImage temp,xpl1+x*intervx*2,ypl1+y*intervy
				SetBuffer ImageBuffer(mask)
				Rect xpl1+x*intervx*2,ypl1+y*intervy,40,40
				DrawImage temp,xpl1+x*intervx*2,ypl1+y*intervy
				DrawImage balls,xpl1+x*intervx*2+ball_ray_x,ypl1+y*intervy+ball_ray_y,8
				GrabImage shapes,xpl1+x*intervx*2,ypl1+y*intervy,y*15+x*2
				i=i+1
			Else
				If x<>7
					SetBuffer ImageBuffer(bitmap(0))
					GrabImage temp,xpl1+x*intervx*2+ball_ray_x,ypl1+y*intervy
					SetBuffer ImageBuffer(mask)
					Rect xpl1+x*intervx*2+ball_ray_x,ypl1+y*intervy,40,40
					DrawImage temp,xpl1+x*intervx*2+ball_ray_x,ypl1+y*intervy
					DrawImage balls,xpl1+x*intervx*2+ball_ray_x*2,ypl1+y*intervy+ball_ray_y,8
					GrabImage shapes,xpl1+x*intervx*2+ball_ray_x,ypl1+y*intervy,y*15+x*2+1
					i=i+1
				EndIf
			EndIf
		Next 
	Next
	ClsColor 0,0,0 : Cls
	MaskImage balls,255,0,255			;restore the mask (last ball is white)
	FreeImage temp
	SetBuffer ImageBuffer(bitmap(0))
	;DrawImage bitmap(2),0,0
	MidHandle shapes
	MaskImage shapes,255,0,255
	Return

;*****************************************************************
.init_vars
	SeedRnd MilliSecs()
	u=0
	For i=0 To 720 Step 1
		fsin(u)=Sin(i)
		fcos(u)=Cos(i)
		u=u+1
	Next
	w=0									;future balls 
	For i=0 To 999						;create 1000 balls from x1 to x2 (from first 1/2 ball+1 to the last-1)
		xfalling(i)=ball_width/2+1+w
		w=(w+1) Mod (((nb_balls_x-1)*ball_width)-2)
	Next 
	For i=0 To 5000						;mix that up!
		r1=Rand(0,999)
		r2=(r1+250+Rand(0,249)) Mod 1000
		;exchange xfalling(r1),xfalling(r2)
		u=xfalling(r1)
		xfalling(r1)=xfalling(r2)
		xfalling(r2)=u
	Next 
	score1=0 : score2=0
	music=True

	xb1#=0 : yb1#=0						;types definition of several variables
	xb2#=0 : yb2#=0 : vol#=0
	x%=0   : y%=0 
	xt%=0  : yt%=0
	boom#=0: i#=0 : o#=0 : u=0
	niveau=0
	computer_level=0
	computer_won_games=0
	player_won_games=0
;	Restore start_arrays
	levels=OpenFile("levels.txt")		;levels loading

	Restore computer_speed
	For i=0 To 49
		Read computer_difficulty(i,1)
		Read computer_difficulty(i,2)
	Next
	Return

.computer_speed
Data 200,1,198,1,196,1,194,1,192,1			;first: speed; 2nd: random average
Data 184,10,182,10,180,10,178,10,176,10
Data 200,30,198,30,196,30,194,30,192,30
Data 170,5,165,5,165,5,160,5,155,5
Data 170,50,165,50,160,50,155,50,150,50
Data 150,10,150,10,150,10,150,10,150,10
Data 120,60,115,40,110,30,105,20,100,10
Data 90,10,90,15,90,20,90,30,90,50
Data 50,10,45,15,40,20,35,25,30,29
Data 20,10,19,11,18,12,17,13,15,14

;*****************************************************************
.init_screen
	SetBuffer FrontBuffer()
	DrawImage bitmap(0),0,0
	SetBuffer BackBuffer()
	DrawImage bitmap(0),0,0
	Flip True
	Return

;*****************************************************************
.new_arrays
	dd=ImagesCollide(mask,0,0,0,maskballs,xpl1+xb1,ypl1+yb1,0) ;one time to avoid little delay the first time in the game
	For i=0 To 5000
		ballslaunched(i)=Rand(0,7)
	Next 
	For y=0 To 12
		For x=0 To 15
			array1(x,y)=-1
			array2(x,y)=-1
			arraydec1(x,y)=-1
			arraydec2(x,y)=-1
		Next 
	Next 

	;loads arrays from levels.txt file
	ln=0
	Repeat
		l$=ReadLine(levels)
		c=0
		s=1
		cl=0
		If Len(l$)>6	;avoid blank lines
			For i=s To Len(l$)
			  If (Mid(l$,i,1)="," Or i=Len(l$)) And c<>0
				bl(cl,ln)=Mid$(l$,s,c)
				s=i+1
				c=0
				cl=cl+1
			  EndIf
			  c=c+1
			Next
			ln=ln+1
		EndIf
	Until l$="9" Or l$="END"
	bl(cl,ln)=9
	If l$="END"
		CloseFile levels
		levels=OpenFile("levels.txt")
	EndIf

	If l$<>"END"
		For y=0 To 12
			For x=0 To 7
				If (y And 1)=0
					num=bl(x,y)
;					Read num
					If num=9 Then Exit
					num=num-1					;to facilitate levels creation (ex, 0 become -1)
					array1(x*2,y)=num
					array2((7-x)*2,y)=array1(x*2,y)
				Else
					If x<>7
						num=bl(x,y)
;						Read num
						If num=9 Then Exit
						num=num-1
						array1(x*2+1,y)=num
						array2((6-x)*2+1,y)=array1(x*2+1,y)
					EndIf
				EndIf
			Next
			If num=9 Then Exit
		Next
	Else											;random level
		For y=0 To 4
			For x=0 To 7
				If (y And 1)=0
					array1(x*2,y)=Rand(0,7)
					array2((7-x)*2,y)=array1(x*2,y)
				Else
					If x<>7
						array1(x*2+1,y)=Rand(0,7)
						array2((6-x)*2+1,y)=array1(x*2+1,y)
					EndIf
				EndIf
			Next
		Next
	EndIf
	Return


;Data 0,0,0,0,0,0,0,0
;Data  0,0,0,0,0,0,0
;Data 0,0,0,0,0,0,0,0
;Data  0,0,0,0,0,0,0
;Data 0,0,0,0,0,0,0,0
;Data  0,0,0,0,0,0,0
;Data 0,0,0,0,0,0,0,0
;Data  0,0,0,0,0,0,0
;Data 0,0,0,0,0,0,0,0
;Data  0,0,0,0,0,0,0
;Data 9

.start_arrays

;*****************************************************************
.draw_balls
	For y=0 To 12
		For x=0 To 14
			If array1(x,y)<>-1
				SetBuffer FrontBuffer()
				DrawImage balls,xpl1+ball_ray_x+x*intervx,ypl1+ball_ray_y+y*intervy,array1(x,y)
				SetBuffer ImageBuffer(bitmap(2))
				DrawImage balls,xpl1+ball_ray_x+x*intervx,ypl1+ball_ray_y+y*intervy,array1(x,y)
				SetBuffer ImageBuffer(mask)
				DrawImage maskballs,xpl1+ball_ray_x+x*intervx,ypl1+ball_ray_y+y*intervy
				SetBuffer BackBuffer()
				DrawImage balls,xpl1+ball_ray_x+x*intervx,ypl1+ball_ray_y+y*intervy,array1(x,y)
			EndIf
			If array2(x,y)<>-1
				SetBuffer FrontBuffer()
				DrawImage balls,xpl2+ball_ray_x+x*intervx,ypl2+ball_ray_y+y*intervy,array2(x,y)
				SetBuffer ImageBuffer(bitmap(2))
				DrawImage balls,xpl2+ball_ray_x+x*intervx,ypl2+ball_ray_y+y*intervy,array2(x,y)
				SetBuffer ImageBuffer(mask)
				DrawImage maskballs,xpl2+ball_ray_x+x*intervx,ypl2+ball_ray_y+y*intervy
				SetBuffer BackBuffer()
				DrawImage balls,xpl2+ball_ray_x+x*intervx,ypl2+ball_ray_y+y*intervy,array2(x,y)
				Delay 13-waittime
				Flip True
			EndIf
		Next
	Next
	Return

;*****************************************************************
.new_level
	SetBuffer FrontBuffer()
	Cls
	DrawImage bitmap(4),0,0
	SetBuffer BackBuffer()
	Cls
	DrawImage bitmap(4),0,0
	bitmap(0)=CopyImage(bitmap(4))
	bitmap(2)=CopyImage(bitmap(4))
	mask=CreateImage(800,600)
	Gosub new_arrays
	Gosub draw_balls
	boom=0
	Return

;*****************************************************************
.get_timing
;	dd=MilliSecs()
;	VWait
;	oo=MilliSecs()
;	t=1000/(oo-dd)
;	min=t : max=t

;	nb=0	
;	Repeat
;		For i=0 To 500
;			VWait
;			oo=MilliSecs()
;			Print oo-dd
;			t=1000/(oo-dd)
;			dd=oo
;			If t<min Then min=t
;			If t>max Then max=t
;		Next
;		min=t : max=t
;		nb=nb+1
;	Until min/10=max/10 Or KeyHit(1) Or nb>=5
	
	option_boom=True
	dd=MilliSecs()
	GrabImage bitmap(1),0,0
	DrawBlockRect bitmap(2),0,0,0,0,ImageWidth(bitmap(1)),ImageHeight(bitmap(1))
	If (MilliSecs()-dd)>5 Then option_boom=False

	Return
	
;*****************************************************************
.accueil
	SetBuffer BackBuffer()
	db=0
	ClsColor 0,0,0
	Cls
	Flip True
	Cls
	jb=loadimg("gfx\0100_jb.jpg")
	DrawImage jb,300,218
	Flip True
	dd=MilliSecs()
	rid1=loadimg("gfx\0100_rideau.png")
	rid2=loadimg("gfx\0100_rideau2.png")
	menu=loadimg("gfx\0100_menu.jpg")
	selec=loadimg("gfx\0100_select.png")
	MaskImage selec,255,255,255
	MaskImage rid1,255,255,255
	MaskImage rid2,255,255,255
	Repeat
		If KeyHit(1) Or JoyHit(1) Then Exit
	Until MilliSecs()>=dd+2000

	FreeImage jb

	.rideau
	FlushKeys
	timer=CreateTimer(60)
	i=199
	While i<=799
		frames=WaitTimer(timer) ;how many times should we update?
		For k=1 To frames
			i=i+4
		Next
		Flip True
		db=1-db
		SetBuffer BackBuffer()
		DrawBlock menu,0,0
		If KeyHit(1)  Or JoyHit(1) Then Exit
		DrawImage rid1,i,0
		DrawImage rid2,-i,0
	Wend
	FreeTimer(timer)
	FlushKeys
	VWait
	Flip True
	Dim sel(6,2)
	sel(0,0)=362 : sel(0,1)=295
	sel(1,0)=294 : sel(1,1)=346
	sel(2,0)=274 : sel(2,1)=391
	sel(3,0)=371 : sel(3,1)=444
	sel(4,0)=381 : sel(4,1)=492
	sel(5,0)=398 : sel(5,1)=540

	.menu
	option=0
	choix=-1
	SetBuffer FrontBuffer()
	DrawImage selec,sel(option,0),sel(option,1)
	Repeat
		oldo=option
		If KeyHit(200) Or JoyYDir()=-1 Then option=(option-1) Mod 6
		If KeyHit(208) Or JoyYDir()=1 Then option=(option+1) Mod 6
		If JoyYDir()<>0 Then 
			Repeat
			Until JoyYDir()=0
		EndIf
		If option=-1 Then option=5 				;negative modulo doesn't work!!!! 
		If option<>oldo
			VWait
			CopyRect sel(oldo,0),sel(oldo,1),43,49,sel(oldo,0),sel(oldo,1),ImageBuffer(menu)
			DrawImage selec,sel(option,0),sel(option,1)
		EndIf
		If KeyHit(28) Or KeyHit(156) Or JoyHit(1) Then choix=option			;enter
	Until KeyHit(1) Or choix<>-1
	CopyRect sel(oldo,0),sel(oldo,1),43,49,sel(oldo,0),sel(oldo,1),ImageBuffer(menu)

	If choix=-1 Or choix=5 Then 
		FreeFont fntArial
		Graphics 800,600,16,2
		ExecFile("http://djes.free.fr") 
		End 			;ESC or quit
	EndIf

	If choix=0 Then Goto menu
	If choix=1
		computer=True		;ai
		decision=False 	
	EndIf
	If choix=2
		computer=False		;ai
		decision=False 	
	EndIf
	If choix=4
		Cls
		FlushKeys
		Text 0,0,"Bobble Puzzle "+version$
		Text 0,20,"By Jsahel Benoist"
		Text 0,40,"http://djes.free.fr  Email : djes@free.fr"
		Text 0,60,"Gifts : 13/2 Bd du Luxembourg, 62400 BETHUNE FRANCE"
		Text 400,300,"Press a key to continue",True,True
		Text 0,535,"Controls : Mouse, joystick or the following keys :"
		Text 0,550,"Player 1 : C, F, V, Left CTRL or Space -> Left, Top, Right, Fire" 
		Text 0,565,"Player 2 : Arrows Left, Up, Right, Right SHIFT or Numpad 0 -> Left, Top, Right, Fire"
		Text 0,580,"Misc.: F1-F7: Display modes; F9: Guide; F10: Boom ON/OFF; P: Pause; M: Music ON/OFF; ESC: Quit"
		Repeat
		Until KeyHit(1) Or JoyHit(1)
		Goto rideau
	EndIf
	If choix=3
		Cls : Flip :Cls
		Gosub check_highscores
		FlushKeys
		Goto rideau
	EndIf

	Flip True
	FreeImage rid1
	FreeImage rid2
	FreeImage menu
	FreeImage selec
	SetBuffer BackBuffer()
	Cls
	Flip True
	SetBuffer BackBuffer()
	Cls
	FlushKeys
	Return

.check_highscores
	highscoresfile=ReadFile("highscores.txt")
	Cls
	Flip True
	SetBuffer FrontBuffer()
	FlushKeys
	Text 0,0,"Bobble Puzzle "+version$
	Text 0,20,"By Jsahel Benoist"
	Text 0,40,"http://djes.free.fr  Email : djes@free.fr"
	Text 0,60,"Gifts : 13/2 Bd du Luxembourg, 62400 BETHUNE FRANCE"

	Text 100,160,"NAME",True,True
	Text 400,160,"SCORE",True,True
	Text 700,160,"LEVEL",True,True
	Line 10,180,790,180
	Line 10,140,790,140

	pos=-1
	For i=0 To 9
		hs_name$(i)=ReadLine(highscoresfile)
		hs_scores(i)=ReadLine(highscoresfile)
		hs_levels(i)=ReadLine(highscoresfile)
		;read the file and automagically insert the new highscore in place (avoid sorting)
		If score1>hs_scores(i) And pos=-1 
			pos=i
			i=i+1
			hs_name$(i)=hs_name$(pos)
			hs_scores(i)=hs_scores(pos)
			hs_levels(i)=hs_levels(pos)
			Text 100,200+i*20,hs_name$(i),True,False
			Text 400,200+i*20,hs_scores(i),True,False
			Text 700,200+i*20,hs_levels(i),True,False
			hs_scores(pos)=score1
			hs_levels(pos)=niveau
			Color 255,255,0
			Text 400,200+pos*20,hs_scores(pos),True,False
			Text 700,200+pos*20,niveau,True,False
			Color 255,255,255
		Else
			Text 100,200+i*20,hs_name$(i),True,False
			Text 400,200+i*20,hs_scores(i),True,False
			Text 700,200+i*20,hs_levels(i),True,False
		EndIf
	Next
	CloseFile highscoresfile
	;new highscores?
	If pos<>-1
		Locate 200,450
		name$=Input("Enter your name : ")
		If name$="" Then name$="Human player"
		hs_name$(pos)=Mid$(name$,1,32)
		Color 255,255,0
		Text 100,200+pos*20,hs_name$(pos),True,False
		Color 0,0,0
		Rect 0,440,799,470,True
		Color 255,255,255
		;save new highscore file
		highscoresfile=WriteFile("highscores.txt")
		For i=0 To 9
			WriteLine highscoresfile,hs_name$(i)
			WriteLine highscoresfile,hs_scores(i)
			WriteLine highscoresfile,hs_levels(i)
		Next
		CloseFile highscoresfile
	EndIf
	Text 400,550,"Press a key to continue",True,True

	WaitKey

	Return

;*****************************************************************
;for ai, avoid misc calculations
.avoid_calc
	If (oldxt<>xt Or oldyt<>yt)	And yt<11


;			SetBuffer BackBuffer()

;			Color 255,255,255
;			Oval xpl2+xbai-8,ypl2+ybai-8,16,16,1

;			Color 255,0,0
;			Oval xpl2+xmid-8,ypl2+ymid-8,16,16,1

;			SetBuffer FrontBuffer()

;			Color 255,255,255
;			Oval xpl2+xbai-8,ypl2+ybai-8,16,16,1

;			Color 255,0,0
;			Oval xpl2+xmid-8,ypl2+ymid-8,16,16,1

		;sur l'axe des x
		If dify=0
			;au point 0
			If difx=0
				;rien de plus
			Else
				;du ct droit ou left
				If difx>0
					hit=getarrayai(xt+1,yt-1)+getarrayai(xt+2,yt)+getarrayai(xt+1,yt+1)
				Else
					hit=getarrayai(xt-1,yt-1)+getarrayai(xt-2,yt)+getarrayai(xt-1,yt+1)
				EndIf
			EndIf
		Else
			;sur l'axe des y
			If difx=0
				;en bas ou en haut
				If dify>0
					hit=getarrayai(xt-1,yt+1)+getarrayai(xt+1,yt+1)
				Else
					hit=getarrayai(xt-1,yt-1)+getarrayai(xt+1,yt-1)
				EndIf
			Else
				;teste chacun des huit quadrants
				If dify<0
					If difx<0
						If Abs(dify)>=Abs(difx)
							hit=getarrayai(xt-2,yt)+getarrayai(xt-1,yt-1)+getarrayai(xt+1,yt-1)
						Else
							hit=getarrayai(xt-1,yt+1)+getarrayai(xt-2,yt)+getarrayai(xt-1,yt-1)
						EndIf
					Else
						If Abs(dify)>=Abs(difx)
							hit=getarrayai(xt+2,yt)+getarrayai(xt+1,yt-1)+getarrayai(xt-1,yt-1)
						Else
							hit=getarrayai(xt+1,yt+1)+getarrayai(xt+2,yt)+getarrayai(xt+1,yt-1)
						EndIf
					EndIf
				Else
					If difx<0
						If Abs(dify)>=Abs(difx)
							hit=getarrayai(xt-2,yt)+getarrayai(xt-1,yt+1)+getarrayai(xt+1,yt+1)
						Else
							hit=getarrayai(xt-1,yt-1)+getarrayai(xt-2,yt)+getarrayai(xt-1,yt+1)
						EndIf
					Else
						If Abs(dify)>=Abs(difx)
							hit=getarrayai(xt+2,yt)+getarrayai(xt+1,yt+1)+getarrayai(xt-1,yt+1)
						Else
							hit=getarrayai(xt+1,yt-1)+getarrayai(xt+2,yt)+getarrayai(xt+1,yt+1)
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
	;;	hit=hit+getarrayai(xt,yt)
	;	If hit<>0 Then DrawImage balls,xpl2+xmid+ball_width/2,ypl2+ymid+ball_height/2,b2
	EndIf
	Return